dh#define BLYNK_PRINT Serial
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <ESP8266mDNS.h>  // For OTA with ESP8266
#include <WiFiUdp.h>  // For OTA
#include <ArduinoOTA.h>  // For OTA
BlynkTimer timer;
#include "OTABlynkCredentials.h"
#include <BlynkSimpleEsp8266.h>
credentials Credentials;
//Variables
char auth_token[33];
bool connected_to_internet = 0;
const int Erasing_button = 15;


//Provide credentials for your ESP server
char* esp_ssid = "tierra";
char* esp_pass = "";

//
void checkPhysicalButton();
int relay1State = LOW;
int pushButton1State = HIGH;
int relay2State = LOW;
int pushButton2State = HIGH;

#define BLYNK_PRINT Serial
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <ESP8266mDNS.h>  // For OTA with ESP8266
#include <WiFiUdp.h>  // For OTA
#include <ArduinoOTA.h>  // For OTA
//BlynkTimer timer;

#define SERVER "blynk-cloud.com "             // Comment-out if use Blynk hosted cloud service
#define PORT 8442
#define RELAY_PIN_1      12   //D6
#define RELAY_PIN_2      16   //D0
#define PUSH_BUTTON_1     2   //D4
#define PUSH_BUTTON_2    14   //D5
#define VPIN_BUTTON_1    V12
#define VPIN_BUTTON_2    V13
#define OTA_HOSTNAME "Home_Automation"

BLYNK_CONNECTED()
{
  // Request the latest state from the server
  Blynk.syncVirtual(VPIN_BUTTON_1);
  Blynk.syncVirtual(VPIN_BUTTON_2);
}
BLYNK_WRITE(VPIN_BUTTON_1)
{
  relay1State = param.asInt();
  digitalWrite(RELAY_PIN_1, relay1State);
}

BLYNK_WRITE(VPIN_BUTTON_2)
{
  relay2State = param.asInt();
  digitalWrite(RELAY_PIN_2, relay2State);
}
//////////////////////////////////////

void checkPhysicalButton()
{
  if (digitalRead(PUSH_BUTTON_1) == LOW)
  {
    if (pushButton1State != LOW)
    {
      relay1State = !relay1State;
      digitalWrite(RELAY_PIN_1, relay1State);
      Blynk.virtualWrite(VPIN_BUTTON_1, relay1State);
    }
    pushButton1State = LOW;
  }
  else
  {
    pushButton1State = HIGH;
  }

  if (digitalRead(PUSH_BUTTON_2) == LOW)
  {
    if (pushButton2State != LOW)
    {
      relay2State = !relay2State;
      digitalWrite(RELAY_PIN_2, relay2State);
      Blynk.virtualWrite(VPIN_BUTTON_2, relay2State);
    }
    pushButton2State = LOW;
  }
  else
  {
    pushButton2State = HIGH;
  }
}

void setup()
{

  Serial.begin(115200);
  pinMode(Erasing_button, INPUT);

  for (uint8_t t = 4; t > 0; t--) {
    Serial.println(t);
    delay(1000);
  }

  // Press and hold the button to erase all the credentials
  if (digitalRead(Erasing_button) == LOW)
  {
    Credentials.Erase_eeprom();
  }

  String auth_string = Credentials.EEPROM_Config();
  auth_string.toCharArray(auth_token, 33);

  if (Credentials.credentials_get())
  {

    Blynk.config(auth_token);
    connected_to_internet = 1;

  }
  else
  {
    Credentials.setupAP(esp_ssid, esp_pass);
    connected_to_internet = 0;
  }


  if (connected_to_internet)
  {
  }

  ArduinoOTA.setHostname(OTA_HOSTNAME);  // For OTA - Use your own device identifying name
  ArduinoOTA.begin();  // For OTA
  pinMode(RELAY_PIN_1, OUTPUT);
  pinMode(PUSH_BUTTON_1, INPUT_PULLUP);
  digitalWrite(RELAY_PIN_1, relay1State);
  pinMode(RELAY_PIN_2, OUTPUT);
  pinMode(PUSH_BUTTON_2, INPUT_PULLUP);
  digitalWrite(RELAY_PIN_2, relay2State);
  timer.setInterval(500L, checkPhysicalButton);
}

void loop()
{
  Credentials.server_loops();
  if (connected_to_internet)
  {
    Blynk.run();
    ArduinoOTA.handle();
    timer.run();
  }
}
